## Entwurf für Zeitplan an A. Niekler

### Von Leo bisher an A. Niekler gesendet: 

#### Phase 1 bis zum 30.11
	
	*  Recherche RASA
	*  Daten sichten 
	*  Generieren der Daten (bspw. durch crawling)
	*  Intens formulieren
	
	* RASA aufsetzen
	* Klassifaktions-Algorithmen auswählen


#### Phase 2 bis zum 14.12

	* Daten aufbereitet haben
	* Protoypen erstellen
	* Leitfragen (teilweise) beantwortet

#### Phase 3 

	* Feedback einarbeiten
	* Finale Version entwickeln


### Zu erstellende Punkte - ToDo

#### Namen und MatNr aller Mitglieder

#### Auflistung der Aufgaben und beabsichtigter Lösungsschritte

##### Zielsetzung Überblick

In dem Projekt soll die Frage geklärt werden, ob Chatbots sich "selbst trainieren können". Dazu soll sich mit der Open-Source Software Rasa auseinandergesetzt werden. Zudem empfiehlt der Betreuer der Gruppe, dass der Chatbot Fragen zu berühmten Physikern beantworten soll. Im Folgenden soll ein Chatbot entwickelt werden, der in englischer Sprache Fragen zu Physikern beantworten kann.

##### 1. Aufgabenbereich: Auseinandersetzung mit Rasa

Anhand der offiziellen Rasa-Dokumentation soll die Funktionsweise von Rasa-Chatbots verstanden werden. Dabei sind Rasa NLU (Natural Language Understanding - soll Absichten des Users verstehen) und Rasa Core (Entscheided über Gesprächsverlauf und generiert Antowrten des Chatbots) zu betrachten. Im nächsten Schritt sollen die Verantwortlichen Rasa auf eigener Hardware in einer lauffähigen Version implementieren. Dazu soll Rasa bevorzugt in einer miniconda-Umgebung laufen (Python 3.6.7). Dies gewährleistet, das alle Teammitglieder Rasa bei sich nutzen können.

3 Abschnitte

* Rasa NLU: Es soll sich damit auseinandergesetzt werden, wie Rasa für Gespräche trainiert wird. Vor allem soll es um die Vermittlung von Intents an Rasa gehen. Für Intents gibt es die besondere Forschungsfrage: "Sind Intents automatisch erzeugbar?" Diese Frage soll im weiteren Verlauf des Projekts geklärt werden. Im ersten Schritt sollen Intents (Thema: Wissen über Physiker s.o.) von den Gruppenmitgliedern formuliert und Rasa damit trainiert werden. 
	- Frage: Was ist ein Intent?
	- Wie müssen Intents für Rasa formuliert werden?
	- Lässt sich ein System erzeugen, dass Intents automatisch erzeugen und in Rasas Syntax ausformulieren kann?
  
**Eine Person sollte zuugeteilt werden**
  
* Rasa Core: Hier sollen die Verantwortlichen ermitteln, wie Rasa auf erkannte Intents reagiert. Versteht Rasa die Intents richtig? Stellt Rasa Core die richtigen Rückfragen? Dazu soll Rasa Core ebenfalls implementiert und trainiert werden. Außerdem soll sich in diesem Teil mit Daten für die Antworten an User (hier: Wissen über Physiker) beschäftigt werden. Auch hier gliedert sich die Aufgabe in zwei Schritte. Im ersten Schritt sollen die Verantwortlichen klären, wie Rasa mit Intents und Daten für die Antwortgenerierung trainiert werden kann. Dazu sollen auch Beispiel-Trainingsdaten manuell erstellt werden und Rasa damit getestet werden. Es ist ein Prototyp zu erstellen, der einfache Fragen zu Physikern beantworten kann. (Beispiele siehe `intents.md`) Rasa bietet zwei Möglichkeiten, Antworten für Bots zu generieren:
	* Im Abschnitt 'Managing Bot Utterances using an external CMS' in der Rasa Documentation wird erklärt, wie die Antwort-Generierung ausgelagert werden kann.
	Dabei kommuniziert der Bot per POST-Request mit einem externen webserver, der wiederum die Antworten generiert und zurücksendet. Die Verantwortlichen sollen einen Flask-Server erstellen, der auf eine SQLite-Datenbank mit den Physikerdaten zurückgreift. (Link: https://rasa.com/docs/core/responses/)
	* Im Abschnitt 'Actions' in der Rasa-Dokumentation wird beschrieben, wie man mit Rasa jeglichen Python-Code für die Generierung von Antworten ausführen kann. Interessant ist hier, dass direkt eine SDK (`rasa_core_sdk`) als Server zur Verfügung gestellt wird. (Link: https://rasa.com/docs/core/customactions/)
	Hier wäre ebenfalls eine probeweise Installation für die Generierung von Antworten interessant

Zusammenfassend:
* Lauffähigen Prototyp erstellen, der auf allen Rechnern läuft
* Training des Bots mit Intents durchführen
* Zwei Möglichkeiten für Antwortgenerierung ausprobieren: Utterances über externes CMS (Flask Server) oder Custom Actions mittels rasa_core_sdk Endpoint

Im zweiten Schritt soll wieder geklärt werden, ob die Wissensgrundlage automatisch erzeugbar ist. Um diese Fragestellung zu beantworten, soll versucht werden, die Rasa Learning Anwendung zu nutzen, um den Bot dazu zu bringen, sich selbst Actions zu schreiben. Es soll versucht werden, dem Bot Actions zu schreiben, mit denen die eigene actions.py-Datei modifiziert wird.

**zwei Personen sollten zugeteilt werden (Lukas?)**

###### Zielsetzung des Aufgabenbereichs:

* Im ersten Schritt soll prototypisch ein Rasa-Chatbot erstellt werden, der Usern verschiedene Fragen zu berühmten Physikern auf Englisch beantworten kann. 

* Im zweiten Schritt soll ein Verfahren erstellt werden, das einen Chatbot während seines Trainings selbst die Trainingsdaten erstellen lässt.

##### 2. Aufgabenbereich: Auseinandersetzung mit Datenbeschaffung

Der zweite Aufgabenbereich soll sich - zunächst unabhängig von Rasa - mit der Akquise von Daten beschäftigen. Der Bot soll in dem Projekt am Beispiel von Physikern arbeiten. Daher soll sich in diesem Schritt mit der Akquise von entsprechenden Daten beschäftigt werden. Es sollen englischsprachige Daten zu bekannten Physikern akquiriert werden. Dazu soll bevorzugt die englischsprachige Wikipedia gecrawlt werden (Ein geladener Datensatz liegt bereits vor). Akquirierte Daten sollen mittels R strukturiert werden. Die zunächst als XML vorliegenden Daten sollen mittels R von Tags, Links etc befreit werden. Wenn möglich soll dann eine Datenbank mit aus den Intents (siehe Aufgabe 1) extrahierten Attributen erstellt werden. Dabei sollen bereits Automatisierungspotenziale aufgedeckt und dokumentiert werden. Zu klärende Fragen:
* Zu welchen Physikern sollen Daten akquiriert werden?
* Wo lassen sich die Daten akquirieren und in welchen Format liegen sie vor?
* Wie lassen sich die Daten in R weiterverarbeiten? - Struktrierung (Namen, Daten, Forschungsgebiete) und Entfernung von Links, Tags etc.
* Wie sollen die Daten gespeichert werden? (SQLite)
* Möglichkeiten der Umwandlung in für Rasa nützlich Form analysiert werden

Im weiteren Verlauf des Projektes soll geklärt werden, inwiefern die oG Aufgaben vom Bot selbst durchgeführt werden können. Ein Anknüpfungspunkt wäre auch hier die Custom Actions aus Aufgabe 1. Es kann zum Beispiel geprüft werden, ob man für den Bot Actions definieren kann, durch die er selbstständig Daten zu einem Thema akquiriert, bearbeitet und abspeichert, um dann darauf zuzugreifen.

**ein bis zwei Personen (David?)**

##### 3. Aufgabenbereich: Dokumentation und Organisation

In diesen Aufgabenbereich fallen alle organisatorischen Aufgaben für das Projekt und die Erstellung Dokumentations- und Präsentationsmedien.

**eine Person oder alle Mitglieder im Wechsel**

#### Architekturdiagramm

#### Grober Zeitplan

#### Absehbare und mögliche Probleme sowie Lösungsansätze
